<?php
// woocommerce-cart-hooks.php

if ( ! defined( 'ABSPATH' ) ) {
    exit;
}

function C5WOO_display_information_in_cart( $item_id, $item, $_product ) {
	$endpoint = get_option( 'wc_C5WOO_settings_endpoint' );
	$token = get_option( 'wc_C5WOO_settings_token' );
	$api_url = C5WOO_REST_API_PATH_PROTOCOL . $endpoint . C5WOO_REST_API_PATH . $token ;
	if( isset( $item['key'] ) ) {
		$build_url = $api_url .'/build/'.$item['key'].'/';
		echo '<div>';
		echo '<a class="c5woo_product_preview" href="https:'.$item['thumbnail_url'].'" target="_blank"><img src="https:'.$item['thumbnail_url'].'"></a> ';
		echo '<a class="btn btn-primary" href="#" id="download_all_'.$item['key'].'"><i class="fa fa-download"></i> '.__( 'Download all photos', C5WOO_DOMAIN ).'</a>';
		echo '<br />'.__( 'Files are available for a period of 15 days.', C5WOO_DOMAIN );
		wp_enqueue_script('jszip',plugins_url('/js/jszip.min.js', __FILE__),'',TRUE);
		wp_enqueue_script('jszip-utils',plugins_url('/js/jszip-utils.js', __FILE__),'',TRUE);
		wp_enqueue_script('FileSaver',plugins_url('/js/FileSaver.min.js', __FILE__),'',TRUE);
		?><script>
        var descriptor_<?php echo $item['key']; ?> = "<?php echo $item['descriptor_url']; ?>";
        var list_<?php echo $item['key']; ?> = [];
        jQuery.getJSON(descriptor_<?php echo $item['key']; ?>, function(d)
        {
            jQuery("#descriptor_<?php echo $item['key']; ?>").text(descriptor_<?php echo $item['key']; ?>);
            for(var idx in d.photos)
            {
                var object = d.photos[idx];
                for (i = 0; i < object.quantity; i++) { 
					var photo = {
						id: object.url.split("/")[6].split(".")[0],
						original_filename: i + "-" + object.filename,
						link: object.url,
						data: null,
						downloaded: false,
						downloading: false
					};
					list_<?php echo $item['key']; ?>.push(photo);
				}
            }
        });

        var ZipImages = function(files)
        {
            this.zip = new JSZip();
            this.files = files;
            this.concurrency = 0;
            this.hashtable_files = {};
            this.hashtable_files[''] = '';
            this.next = function()
            {
                var done = true;
                for(var idx in _this.files)
                {
                    if(!_this.files[idx].downloading)
                    {
                        _this.files[idx].downloading = true;
                        _this.download_image(_this.files[idx], function() {
                            _this.next();
                        });
                        done = false;
                        break;
                    }
                }

                if(!done && _this.concurrency < 5) {
                    _this.next();
                }
                if(done) { _this.finalize(); }
            };

            this.download_image = function(file, callback)
            {
                _this.concurrency ++;
                jQuery("#currentfile").text(file.original_filename);

                JSZipUtils.getBinaryContent(file.link, function (err, data)
                {
                    if(err) {
                        console.error(err);
                    } else {
                        file.data = data;
                        file.downloaded = true;
                    }
                    
                    _this.concurrency --;
                    callback();
                });
            };

            this.slugify = function(text)
            {
                return text.toString().toLowerCase()
                    .replace(/\s+/g, '-')
                    .replace(/[^\w\-]+/g, '')
                    .replace(/\-\-+/g, '-')
                    .replace(/^-+/, '')
                    .replace(/-+$/, '');
            };

            this.get_filename = function(filename)
            {
                var uniqfier = function(f) {
                    var i = 0;
                    while(true) {
                        i++;
                        var lst = f.lastIndexOf(".");
                        var filename = f.substr(0,lst) + i.toString() + f.substr(lst);
                        if(typeof _this.hashtable_files[filename.toLowerCase()] == "undefined") {
                            break;
                        }
                    }
                    return filename;
                };

                var s = filename.split("?")[0].split("#")[0]
                    .replace(/\s+/g, '-')
                    .replace(/[^\w\-_\.]+/g, '')
                    .replace(/\-\-+/g, '-')
                    .replace(/^-+/, '')
                    .replace(/-+$/, '');

                if(typeof _this.hashtable_files[s.toLowerCase()] != "undefined") {
                    s = uniqfier(s);
                }
                _this.hashtable_files[s.toLowerCase()] = s;
                return s;
            };

            this.finalize = function() {
                for(var idx in _this.files) {
                    if(!_this.files[idx].downloaded) { return; }
                }

                for(var idx in _this.files)
                {
                    var file = _this.files[idx];
                    _this.zip.file(_this.get_filename(file.original_filename), file.data, {base64:true});
                    
                    file.data = null;
                    delete file.data;
                    
                    jQuery("#compress").text(file.original_filename);
                }
                var content = _this.zip.generate({type:"blob"});
                var orderid = "<?php echo(get_the_ID()); ?>";
				saveAs(content, "order-"+orderid+".zip");
                
            };
            var _this = this;
        };

        jQuery("#download_all_<?php echo $item['key']; ?>").on("click", function(){
			var xhr = new XMLHttpRequest();
			var url = "<?php echo $build_url; ?>";
			xhr.open("POST", url, true);
			xhr.setRequestHeader("Content-Type", "application/json");
			var data = JSON.stringify({"productGroup": "<?php echo $item['productGroup']; ?>", "quantity": "<?php echo $item['quantity']; ?>"});
			xhr.send(data);

            if(!list_<?php echo $item['key']; ?>[0]) return;
            var z = new ZipImages(list_<?php echo $item['key']; ?>);
            z.next();
        });
    </script><?php
		echo '</div>';
	}
	if( isset( $item['saved_key'] ) ) {
		$build_url = $api_url .'/build/'.$item['saved_key'].'/';
		$check_url = $api_url .'/check/'.$item['saved_key'].'/';
		echo '<div>';
		echo '<a class="c5woo_product_preview" href="https:'.$item['thumbnail_url'].'" target="_blank"><img src="https:'.$item['thumbnail_url'].'"></a> ';
		if (isset($_GET['c5woo_action']) ) {
			if ( $_GET['c5woo_action'] == 'build' && $_GET['c5woo_saved_key'] == $item['saved_key'] ) {
				$content = json_encode(array(
					"productGroup" => $item['productGroup'],
					"quantity" => $item['quantity']
				));
				$request = wp_remote_post( $build_url, array(
					'method' => 'POST',
					'timeout' => 45,
					'redirection' => 5,
					'httpversion' => '1.0',
					'blocking' => true,
					'headers' => array("Content-type: application/json"),
					'body' => $content,
					'cookies' => array()
					)
				);
				$response = wp_remote_retrieve_body($request);
				echo "<script> console.log($response);</script>";
				if ( is_wp_error( $request ) ) {
				   $error_message = $request->get_error_message();
				   echo "Something went wrong: $error_message";
				}
				$data = json_decode($response);
			}
			if ( $_GET['c5woo_action'] == 'check' && $_GET['c5woo_saved_key'] == $item['saved_key'] ) {
				$request = wp_remote_get($check_url, array(
					'method' => 'GET',
					'timeout' => 45,
					'redirection' => 5,
					'httpversion' => '1.0',
					'blocking' => true,
					'headers' => array("Content-type: application/json"),
					'cookies' => array()
					)
				);
				$response = wp_remote_retrieve_body($request);
				$data = json_decode($response);
			}
		}
		else {
			$request = wp_remote_get($check_url, array(
				'method' => 'GET',
				'timeout' => 45,
				'redirection' => 5,
				'httpversion' => '1.0',
				'blocking' => true,
				'headers' => array("Content-type: application/json"),
				'cookies' => array()
				)
			);
			$response = wp_remote_retrieve_body($request);
			$data = json_decode($response);
			if ( $data->error )
				echo $data->error;
			else {
				if( !$data->expired ) {
					if( $data->built )
						echo '<a class="c5woo_download_link" href="'.$data->files[0]->url.'">'.__( 'Download product', C5WOO_DOMAIN ).'</a> ';
					else {
						if ( $data->percent_done) {
							echo 'Build progress: ' . $data->percent_done . ' % ';
							$message = '<p>Maintenance: Build progress: ' . $data->percent_done . ' %, <a href="' . $check_url . '">Check URL</a></p>';
							c5woo_send_maintenance_email($message);
						}
						else
							echo '<a class="c5woo_build_link" href="post.php?post='. get_the_ID() .'&action=edit&c5woo_action=build&c5woo_saved_key='.$item['saved_key'].'">'.__( 'Build product', C5WOO_DOMAIN ).'</a> ';
					}
				}
				else
					echo __( 'Product has expired and can not be downloaded anymore.', C5WOO_DOMAIN );
			}
			echo '<a class="c5woo_api_link" href="'.$check_url.'" target="_blank">'.__( 'Check API', C5WOO_DOMAIN ).'</a> ';
		}
		echo '</div>';
	}
}
add_action( 'woocommerce_after_order_itemmeta', 'C5WOO_display_information_in_cart', 10, 3 );