<?php
// woocommerce-products-options-attribute.php
// adds a Creator Five ID field on the products' page

if ( ! defined( 'ABSPATH' ) ) {
    exit;
}

add_action( 'woocommerce_product_options_general_product_data', 'C5WOO_add_custom_general_field_for_creator_five' );
function C5WOO_add_custom_general_field_for_creator_five() {

	global $post;

	$slug = get_option( 'wc_C5WOO_settings_endpoint' );
	echo '<div class="options_group">';
	$creator_five_product_id = get_post_meta( $post->ID, 'creator_five_product_id', true );
	$creator_five_product_id = substr($creator_five_product_id, 0, strpos($creator_five_product_id, ';'));
	echo '<p class="form-field creator_five_product_id">';
	echo '<label for="creator_five_product_id">'. __( 'Creator Five product ID', C5WOO_DOMAIN ) .'</label>';
	echo '<select id="creator_five_product_id" name="creator_five_product_id" onchange="OnChangeProductID(this.form.creator_five_product_id);">';
	echo '<option value="0;none">'. __( 'None', C5WOO_DOMAIN ) .'</option>';

	$list_product_url = 'https://'.$slug.'.creatorfive.com/api/list-products/';
	$request = wp_remote_get($list_product_url, array(
		'method' => 'GET',
		'timeout' => 45,
		'redirection' => 5,
		'httpversion' => '1.0',
		'blocking' => true,
		'headers' => array("Content-type: application/json"),
		'cookies' => array()
		)
	);
	$product_list = wp_remote_retrieve_body($request);
	$products = json_decode($product_list);
	foreach ($products as $product) {
		foreach ($product->products as $variation) {
			echo '<option value="'.$variation->id.';'.$product->type.'"';
			if ( $variation->id == $creator_five_product_id) {
				echo ' selected="selected"';
				$product_type = $product->type;
				$product_productGroup = $product->productGroup;
			}
			echo '>'.$product->title. ' / '.$variation->name.'</option>';
		}
	}
	echo '</select>';
	echo '</p>';
?><script>
	var jsonData = {"creator_five_product_id":[<?php
	foreach ($products as $product) {
		foreach ($product->products as $variation) {
			echo '{"id":"'.$variation->id.'","creator_five_product_type":"'.$product->type.'","creator_five_productGroup":"'.$product->productGroup.'"},';
		}
	}?>]};

	function OnChangeProductID(dropdown){
		var id = dropdown.selectedIndex;
		id = id - 1 ;
		var creator_five_product_type = jsonData.creator_five_product_id[id].creator_five_product_type;
		var creator_five_productGroup = jsonData.creator_five_product_id[id].creator_five_productGroup;
		document.getElementById("creator_five_product_type").value = creator_five_product_type;
		document.getElementById("creator_five_productGroup").value = creator_five_productGroup;
		return true;

	}
</script><?php
/*
	woocommerce_wp_select( array(
		'id' => 'creator_five_product_id',
		'label' => __('Creator Five product ID', C5WOO_DOMAIN ),
		'type' => 'select',
		'options' => array('none' => __( 'None', C5WOO_DOMAIN ), $homepage => __('Shop', C5WOO_DOMAIN ),$cartpage => __('Cart', C5WOO_DOMAIN ))
	) );
*/

	$creator_five_theme_type = get_post_meta( $post->ID, 'creator_five_theme_type', true );
	echo '<p class="form-field creator_five_theme_type">';
	echo '<label for="creator_five_theme_type">'. __( 'Creator Five theme', C5WOO_DOMAIN ) .'</label>';
	echo '<select id="creator_five_theme_type" name="creator_five_theme_type">';
	echo '<option value="none">'. __( 'None', C5WOO_DOMAIN ) .'</option>';
	
	$list_themes_url = 'https://'.$slug.'.creatorfive.com/api/list-theme-types/';
	$request = wp_remote_get($list_themes_url, array(
		'method' => 'GET',
		'timeout' => 45,
		'redirection' => 5,
		'httpversion' => '1.0',
		'blocking' => true,
		'headers' => array("Content-type: application/json"),
		'cookies' => array()
		)
	);
	$theme_list = wp_remote_retrieve_body($request);
	$themes = json_decode($theme_list);
	foreach ($themes as $theme) {
		echo '<option value="'.$theme.'"';
		if ( $theme == $creator_five_theme_type) {
			echo ' selected="selected"';
			$creator_five_theme_type = $theme;
		}
		echo '>'.$theme.'</option>';
	}
	echo '</select>';
	echo '</p>';
	echo '</div>';

/*
	woocommerce_wp_select( array(
		'id' => 'creator_five_theme_type',
		'label' => __('Creator Five theme', C5WOO_DOMAIN ),
		'type' => 'select',
		'options' => array('none' => __( 'None', C5WOO_DOMAIN ), $homepage => __('Shop', C5WOO_DOMAIN ),$cartpage => __('Cart', C5WOO_DOMAIN ))
	) );
*/

	woocommerce_wp_hidden_input( array( 'id' => 'creator_five_product_type', 'value' => $product_type) );
	woocommerce_wp_hidden_input( array( 'id' => 'creator_five_productGroup', 'value' => $product_productGroup) );
}

add_action( 'woocommerce_process_product_meta', 'C5WOO_add_custom_general_field_for_creator_five_save', 10, 2 );
function C5WOO_add_custom_general_field_for_creator_five_save( $post_id ){
	$creator_five_product_id = $_POST['creator_five_product_id'];
	if( !empty( $creator_five_product_id ) )
		update_post_meta( $post_id, 'creator_five_product_id', esc_attr( $creator_five_product_id ) );
	$creator_five_product_type = $_POST['creator_five_product_type'];
	if( !empty( $creator_five_product_type ) )
		update_post_meta( $post_id, 'product_type', esc_attr( $creator_five_product_type ) );
	$creator_five_productGroup = $_POST['creator_five_productGroup'];
	if( !empty( $creator_five_productGroup ) )
		update_post_meta( $post_id, 'productGroup', esc_attr( $creator_five_productGroup ) );
	$creator_five_theme_type = $_POST['creator_five_theme_type'];
	if( !empty( $creator_five_theme_type ) )
		update_post_meta( $post_id, 'creator_five_theme_type', esc_attr( $creator_five_theme_type ) );
}