<?php

if ( ! defined( 'ABSPATH' ) ) {
    exit;
}

function C5WOO_run_builds($text, $order_id) {
	$endpoint = get_option( 'wc_C5WOO_settings_endpoint' );
	$token = get_option( 'wc_C5WOO_settings_token' );

	$order = new WC_Order( $order_id );
	$order_data = $order->get_data();
	
	$items = $order->get_items();
	foreach ($items as $item){
		if( isset( $item['key'] ) ) {
			$build_url = C5WOO_REST_API_PATH_PROTOCOL . $endpoint . C5WOO_REST_API_PATH . $token .'/build/'.$item['key'].'/';
		}
		if( isset( $item['saved_key'] ) ) {
			$build_url = C5WOO_REST_API_PATH_PROTOCOL . $endpoint . C5WOO_REST_API_PATH . $token .'/build/'.$item['saved_key'].'/';
		}
		$content = json_encode(array(
			"productGroup" => $item['productGroup'],
			"quantity" => $item['quantity']
		));
		$request = wp_remote_post( $build_url, array(
			'method' => 'POST',
			'timeout' => 45,
			'redirection' => 5,
			'httpversion' => '1.0',
			'blocking' => true,
			'headers' => array("Content-type: application/json"),
			'body' => $content,
			'cookies' => array()
			)
		);
//		$response = wp_remote_retrieve_body($request);
	}
}
add_filter('woocommerce_thankyou_order_received_text', 'C5WOO_run_builds', 10, 2 );