<?php
// woocommerce-settings-tab.php

if ( ! defined( 'ABSPATH' ) ) {
    exit;
}

add_filter( 'woocommerce_settings_tabs_array', 'C5WOO_add_creatorfive_settings_tab', 50 );

function C5WOO_add_creatorfive_settings_tab($settings_tabs) {
	$settings_tabs['creatorfive'] = __( 'Creator Five', 'creator-five-for-woocommerce' );
	return $settings_tabs;
}

add_action( 'woocommerce_settings_tabs_creatorfive', 'C5WOO_settings_tab' );

function C5WOO_settings_tab() {
    woocommerce_admin_fields( C5WOO_get_C5WOO_settings() );
}

add_action( 'woocommerce_update_options_creatorfive', 'C5WOO_update_C5WOO_settings' );

function C5WOO_update_C5WOO_settings() {
    woocommerce_update_options( C5WOO_get_C5WOO_settings() );
}

function C5WOO_get_C5WOO_settings() {
	$homepage = get_permalink( wc_get_page_id( 'shop' ) );
	$cartpage = wc_get_cart_url();
	$settings = array(
		'section_title' => array(
			'name' => __('Creator Five Settings', 'creator-five-for-woocommerce'),
			'type' => 'title',
			'desc' => __('The following options are used to configure Creator Five.', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_settings_section_title'
		),
		'endpoint' => array(
			'name' => __('Creator Five endpoint', 'creator-five-for-woocommerce'),
			'type' => 'text',
			'css' => 'min-width:200px;',
			'desc' => __('Your Creator Five endpoint (without .creatorfive.com/api)', 'creator-five-for-woocommerce'),
			'desc_tip' => __('Your Creator Five endpoint (without .creatorfive.com/api)', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_settings_endpoint'
		),
		'token' => array(
			'name' => __('Creator Five API token', 'creator-five-for-woocommerce'),
			'type' => 'text',
			'css' => 'min-width:200px;',
			'desc' => __('Your Creator Five API token', 'creator-five-for-woocommerce'),
			'desc_tip' => __('Your Creator Five API token', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_settings_token'
		),
		'creator_five_editor_personalize_link' => array(
			'name' => __('Personalize link CSS', 'creator-five-for-woocommerce'),
			'type' => 'text',
			'css' => 'min-width:200px;',
			'desc' => __('Your Personalize link CSS (optional)', 'creator-five-for-woocommerce'),
			'desc_tip' => __('In order to display the button, some themes may require: display:inline-block;', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_settings_css_creator_five_editor_personalize_link'
		),
		'creator_five_editor_personalize_button' => array(
			'name' => __('Personalize button CSS', 'creator-five-for-woocommerce'),
			'type' => 'text',
			'css' => 'min-width:200px;',
			'desc' => __('Your Personalize button CSS (optional)', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_settings_css_creator_five_editor_personalize_button'
		),
		'section_end' => array(
			'type' => 'sectionend',
			'id' => 'wc_C5WOO_settings_section_end'
		),
		'second_section_title' => array(
			'name' => __('Editor general customization', 'creator-five-for-woocommerce'),
			'type' => 'title',
			'desc' => __('These settings provide for general customization of the editor.', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_settings_second_section_title'
		),
		'logo_url' => array(
			'name' => __('Creator Five logo url', 'creator-five-for-woocommerce'),
			'type' => 'text',
			'css' => 'min-width:200px;',
			'desc' => __('Your Creator Five logo url (optional)', 'creator-five-for-woocommerce'),
			'desc_tip' => __('Your logo will be displayed in the upper left corner of the application. The maximum height should be 48 pixels, the recommended width is about 300 pixels. If left blank, the default Creator Five logo is displayed.', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_settings_logo_url'
		),
		'logo_link' => array(
			'name' => __('Creator Five logo link', 'creator-five-for-woocommerce'),
			'type' => 'text',
			'css' => 'min-width:200px;',
			'desc' => __('Your Creator Five logo link (optional)', 'creator-five-for-woocommerce'),
			'desc_tip' => __('This link will be followed when customer click on your logo. If left blank, no link will be set for the logo.', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_settings_logo_link'
		),
		'complete_redirect' => array(
			'name' => __('Redirection', 'creator-five-for-woocommerce'),
			'type' => 'select',
			'css' => 'min-width:200px;',
			'options' => array($homepage => __('Shop', 'creator-five-for-woocommerce'),$cartpage => __('Cart', 'creator-five-for-woocommerce')),
			'desc' => __('Customers redirect after adding product to cart.', 'creator-five-for-woocommerce'),
			'desc_tip' => __('Customers will be redirected to this page after adding product(s) to cart.', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_complete_redirect',
			'class' => 'wc-enhanced-select'
		),
		'second_section_end' => array(
			'type' => 'sectionend',
			'id' => 'wc_C5WOO_settings_second_section_end'
		),
		'third_section_title' => array(
			'name' => __('Creations’ editor customization', 'creator-five-for-woocommerce'),
			'type' => 'title',
			'desc' => __('These settings provide for customizing the creations’editor.', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_settings_third_section_title'
		),
		'customer_login' => array(
			'name' => __('Check if customer logged in', 'creator-five-for-woocommerce'),
			'type' => 'checkbox',
			'desc' => __('Checks if customer is logged in and offers to login if not.', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_settings_customer_login'
		),
		'creations_editor_button_text' => array(
			'name' => __('Creations’ editor button text', 'creator-five-for-woocommerce'),
			'type' => 'text',
			'css' => 'min-width:200px;',
			'desc' => __('Creations’ editor button text', 'creator-five-for-woocommerce'),
			'desc_tip' => __('If left blank, the default button text will be displayed.', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_settings_creations_editor_button_text'
		),
		'ressource_manager_name' => array(
			'name' => __('Resource Manager name', 'creator-five-for-woocommerce'),
			'type' => 'text',
			'css' => 'min-width:200px;',
			'desc' => __('Your Resource Manager name (optional)', 'creator-five-for-woocommerce'),
			'desc_tip' => __('If left blank, a default set of resources will be loaded.', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_settings_ressource_manager_name'
		),
		'photobook_pages_option_name' => array(
			'name' => __('Slug of the photobook number of pages option', 'creator-five-for-woocommerce'),
			'type' => 'text',
			'css' => 'min-width:200px;',
			'desc' => __('Slug of the photobook number of pages option', 'creator-five-for-woocommerce'),
			'desc_tip' => __('Required if managing photobooks with variable number of pages, name of the photobook number of pages option as slug', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_settings_photobook_pages_option_name'
		),
		'welcomeScreen' => array(
			'name' => __('Theme selection screen', 'creator-five-for-woocommerce'),
			'type' => 'checkbox',
			'desc' => __('Adds theme selection screen at startup.', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_settings_welcomeScreen'
		),
		'googleFontList' => array(
			'name' => __('List of Google Fonts', 'creator-five-for-woocommerce'),
			'type' => 'textarea',
			'css' => 'min-width:200px;',
//			'desc' => __('Loads a given list of Google Fonts (optional)', 'creator-five-for-woocommerce'),
			'desc_tip' => __('Loads a given list of Google Fonts (spaces need to be replaced by +). If left blank, a default set of Google Fonts will be loaded.', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_settings_googleFontList'
		),
/*
		'creations_duration' => array(
			'name' => __('Duration of the creations', 'creator-five-for-woocommerce'),
			'type' => 'select',
			'css' => 'min-width:200px;',
			'options' => array('2592000' => __('30 days', 'creator-five-for-woocommerce'),'5184000' => __('60 days', 'creator-five-for-woocommerce'),'7776000' => __('90 days', 'creator-five-for-woocommerce'),'15552000' => __('180 days', 'creator-five-for-woocommerce'),'31104000' => __('360 days', 'creator-five-for-woocommerce'),'62208000' => __('720 days', 'creator-five-for-woocommerce')),
			'desc' => __('Duration for which the creations remain available.', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_settings_creations_duration'
		),
*/
		'advancedAutofill' => array(
			'name' => __('Advanced Autofill', 'creator-five-for-woocommerce'),
			'type' => 'checkbox',
			'id' => 'wc_C5WOO_settings_advancedAutofill',
			'desc' => __('Advanced Autofill (books only)', 'creator-five-for-woocommerce'),
			'desc_tip' => __('Adds advanced Autofill settings (books only).', 'creator-five-for-woocommerce')
		),
		'third_section_end' => array(
			'type' => 'sectionend',
			'id' => 'wc_C5WOO_settings_third_section_end'
		),
		'fourth_section_title' => array(
			'name' => __('Prints’ ordering tool customization', 'creator-five-for-woocommerce'),
			'type' => 'title',
			'desc' => __('These settings provide for the customization of the prints’ ordering tool.', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_settings_fourth_section_title'
		),
		'prints_ordering_button_text' => array(
			'name' => __('Prints ordering button text', 'creator-five-for-woocommerce'),
			'type' => 'text',
			'css' => 'min-width:200px;',
			'desc' => __('Prints ordering button text', 'creator-five-for-woocommerce'),
			'desc_tip' => __('If left blank, the default button text will be displayed.', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_settings_prints_ordering_button_text'
		),
		'photo_container_width' => array(
			'name' => __('Width of the photo container', 'creator-five-for-woocommerce'),
			'type' => 'text',
			'css' => 'min-width:200px;',
			'desc' => __('Width of the photo container in pixels', 'creator-five-for-woocommerce'),
			'desc_tip' => __('If left blank, a default width of 310 pixels will be applied to the photo container.', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_settings_photo_container_width'
		),
		'show_scissors' => array(
			'name' => __('Show scissors', 'creator-five-for-woocommerce'),
			'type' => 'checkbox',
			'desc' => __('Display photo croping scissors', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_settings_show_scissors'
		),
		'fourth_section_end' => array(
			'type' => 'sectionend',
			'id' => 'wc_C5WOO_settings_fourth_section_end'
		),
		'fifth_section_title' => array(
			'name' => __('Social networks integration (beta)', 'creator-five-for-woocommerce'),
			'type' => 'title',
			'desc' => __('These settings provide for enabling social networks applications.', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_settings_fifth_section_title'
		),
		'facebook_appid' => array(
			'name' => __('facebook appid', 'creator-five-for-woocommerce'),
			'type' => 'text',
			'css' => 'min-width:200px;',
			'desc' => __('Your facebook appid (optional)', 'creator-five-for-woocommerce'),
			'desc_tip' => __('This appid will enable importing photos from facebook.', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_settings_facebook_appid'
		),
		'instagram_clientid' => array(
			'name' => __('Instagram clientid', 'creator-five-for-woocommerce'),
			'type' => 'text',
			'css' => 'min-width:200px;',
			'desc' => __('Your Instagram clientid (optional)', 'creator-five-for-woocommerce'),
			'desc_tip' => __('This clientid will enable importing photos from Instagram.', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_settings_instagram_clientid'
		),
		'google_clientid' => array(
			'name' => __('Google clientid', 'creator-five-for-woocommerce'),
			'type' => 'text',
			'css' => 'min-width:200px;',
			'desc' => __('Your Google clientid (optional)', 'creator-five-for-woocommerce'),
			'desc_tip' => __('This clientid will enable importing photos from Google Photos.', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_settings_google_clientid'
		),
		'fifth_section_end' => array(
			'type' => 'sectionend',
			'id' => 'wc_C5WOO_settings_fifth_section_end'
		),
		'sixth_section_title' => array(
			'name' => __('Miscellaneous', 'creator-five-for-woocommerce'),
			'type' => 'title',
			'desc' => __('These settings provide for miscellaneous customization.', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_settings_sixth_section_title'
		),
		'display_debug_info_in_cart' => array(
			'name' => __('Debug information in cart', 'creator-five-for-woocommerce'),
			'type' => 'checkbox',
			'desc' => __('Display debug information in cart', 'creator-five-for-woocommerce'),
			'desc_tip' => __('Displays item meta data information in cart for debugging purposes.', 'creator-five-for-woocommerce'),
			'id' => 'wc_C5WOO_settings_display_debug_info_in_cart'
		),
		'automaticproduction' => array(
			'name' => __('Activate automatic production', 'creator-five-for-woocommerce'),
			'type' => 'checkbox',
			'id' => 'wc_C5WOO_settings_automaticproduction',
			'desc' => __('Automatic generation of production files.', 'creator-five-for-woocommerce'),
			'desc_tip' => __('The automatic production automatically starts the generation of production files.', 'creator-five-for-woocommerce')
		),
		'sixth_section_end' => array(
			'type' => 'sectionend',
			'id' => 'wc_C5WOO_settings_sixth_section_end'
		)
	);
	return apply_filters( 'wc_C5WOO_settings', $settings );
}
