<?php
// woocommerce-status-tab.php

if ( ! defined( 'ABSPATH' ) ) {
    exit;
}

// Add a custom tab to WooCommerce Status section
add_filter('woocommerce_admin_status_tabs','C5WOO_add_custom_admin_status_tabs', 10, 1);
function C5WOO_add_custom_admin_status_tabs( $tabs ){
    $tabs['creator_five'] = __( 'Creator Five', 'creator-five-for-woocommerce' );
    return $tabs;
}

// Add the content of the custom tab to WooCommerce Status section
// ( HERE the hook is maid of 'woocommerce_admin_status_content_' + the slug of this tab )
add_action( 'woocommerce_admin_status_content_creator_five', 'C5WOO_add_custom_admin_status_content_creator_five' );
function C5WOO_add_custom_admin_status_content_creator_five(){
	global $wpdb;
    $table_prefix = $wpdb->prefix;
	$key_slug = 'creator_five';

	$sql = "SELECT ID, post_title, ".$table_prefix."postmeta.meta_key, ".$table_prefix."postmeta.meta_value ";
	$sql .= "FROM ".$table_prefix."posts, ".$table_prefix."postmeta ";
	$sql .= "WHERE post_type = 'product' AND ".$table_prefix."posts.ID = ".$table_prefix."postmeta.post_id AND ".$table_prefix."postmeta.meta_key IN ('product_type', 'productGroup', 'creator_five_theme_type') ";
	$sql .= "ORDER BY post_title;";
	$result = $wpdb->get_results( $sql, OBJECT );
    ?>
    <h1><?php _e( 'Creator Five enabled products', 'creator-five-for-woocommerce' ); ?></h1><table class="wc_status_table wc_status_table--<?php echo $key_slug; ?> widefat" cellspacing="0">
	<p><?php _e( 'This table lists the Creator Five enabled product along with their hidden parameters. If a product is missing from this list, it will not be properly managed with Creator Five. Please fix it.', 'creator-five-for-woocommerce' ); ?></p>
        <tbody class="<?php echo $key_slug; ?>">
            <tr class="section-name-1" >
                <th><strong><?php _e( 'Product name', 'creator-five-for-woocommerce' ); ?></strong></th>
                <th><strong><?php _e( 'Attribute name', 'creator-five-for-woocommerce' ); ?></strong></th>
                <th><strong><?php _e( 'Attribute value', 'creator-five-for-woocommerce' ); ?></strong></th>
			</tr>
	<?php
	foreach ($result as $product) {
		echo '<tr><td><a href="./post.php?post='.$product->ID.'&action=edit">'.$product->post_title.'</a></td><td>'.$product->meta_key.'</td><td>'.$product->meta_value.'</td></tr>';
	}
    ?>
		</tbody>
    </table>
    <?php
}