<?php

if ( ! defined( 'ABSPATH' ) ) {
    exit;
}

class creator_five_product {
	
	public $product_id;
	public $product_is_variable;
	public $product_name;
	public $product_group;
	public $product_type;
	public $theme_type;
	public $variation_id;
	
	public function __construct($product_id) {
		global $product;

		$product = wc_get_product($product_id);

		$creator_five_product_id = get_post_meta( $product_id, 'creator_five_product_id', true );
		$this->product_name = get_the_title( $product_id );
		$creator_five_product = explode(";", $creator_five_product_id);
		$this->product_id = $creator_five_product[0];
		$this->product_type = $creator_five_product[1];
		$this->product_group = get_post_meta( $product_id, 'productGroup', true );
		$this->theme_type = get_post_meta( $product_id, 'creator_five_theme_type', true );
		if ( $product->is_type( 'variable' ) ) {
			$this->variation_id = 0;
			$this->product_is_variable = true;
		}
		else {
			$this->variation_id = 0;
			$this->product_is_variable = false;
		}
	}
}

class creator_five_editor {

	public $advancedAutofill;
	public $complete_redirect;
	public $googleFontList;
	public $facebook_appid;
	public $google_clientid;
	public $instagram_clientid;
	public $logo_link;
	public $logo_url;
	public $photo_container_width;
	public $photobook_pages_option_name;
	public $ressource_manager_name;
	public $show_scissors;
	public $slug;
	public $welcomeScreen;
	
	public function __construct() {

		if (get_option( 'wc_C5WOO_settings_advancedAutofill' ) == 'no')
			$this->advancedAutofill = 'false';
		else
			$this->advancedAutofill = 'true';

		if (get_option( 'wc_C5WOO_complete_redirect' ) == '')
			$this->complete_redirect = wc_get_cart_url();
		else
			$this->complete_redirect = get_option( 'wc_C5WOO_complete_redirect' );	
	
		$this->googleFontList = get_option( 'wc_C5WOO_settings_googleFontList' );
		$this->facebook_appid = get_option( 'wc_C5WOO_settings_facebook_appid' );
		$this->google_clientid = get_option( 'wc_C5WOO_settings_google_clientid' );
		$this->instagram_clientid = get_option( 'wc_C5WOO_settings_instagram_clientid' );

		if (get_option( 'wc_C5WOO_settings_logo_link' ) == '')
			$this->logo_link = get_site_url();
		else
			$this->logo_link = get_option( 'wc_C5WOO_settings_logo_link' );

		if (get_option( 'wc_C5WOO_settings_logo_url' ) == '')
			$this->logo_url = plugins_url( '../public/img/logo_creatorfive.svg', __FILE__ );
		else
			$this->logo_url = get_option( 'wc_C5WOO_settings_logo_url' );

		$this->slug = get_option( 'wc_C5WOO_settings_endpoint' );

		if (get_option( 'wc_C5WOO_settings_photo_container_width' ) == '')
			$this->photo_container_width = '310';
		else
			$this->photo_container_width = get_option( 'wc_C5WOO_settings_photo_container_width' );

		$this->photobook_pages_option_name = get_option( 'wc_C5WOO_settings_photobook_pages_option_name' );

		if (get_option( 'wc_C5WOO_settings_ressource_manager_name' ) == '')
			$this->ressource_manager_name = 'inboxphoto';
		else
			$this->ressource_manager_name = get_option( 'wc_C5WOO_settings_ressource_manager_name' );

		if (get_option( 'wc_C5WOO_settings_show_scissors' ) == 'no')
			$this->show_scissors = 'false';
		else
			$this->show_scissors = 'true';

		if (get_option( 'wc_C5WOO_settings_welcomeScreen' ) == 'no')
			$this->welcomeScreen = 'false';
		else
			$this->welcomeScreen = 'true';
	}
}