<?php

if ( ! defined( 'ABSPATH' ) ) {
    exit;
}

add_filter( 'woocommerce_account_menu_items', 'C5WOO_account_menu_items', 10, 1 );
function C5WOO_account_menu_items( $items ) {
	$logout = $items['customer-logout'];
	unset( $items['customer-logout'] );
	$items['stored-creations'] = __( 'Stored creations', 'creator-five-for-woocommerce' );
	$items['customer-logout'] = $logout;
    return $items;
}

add_action( 'woocommerce_account_stored-creations_endpoint', 'C5WOO_stored_creations_endpoint_content' );
function C5WOO_stored_creations_endpoint_content() {
	wp_localize_script('script', 'ajaxurl', admin_url( 'admin-ajax.php' ) );
	global $woocommerce, $wpdb;
	if(is_user_logged_in()) {
		$user = get_current_user_id();
		echo '<h2>'. __( 'Stored creations', 'creator-five-for-woocommerce' ).'</h2>';
		echo '<p>'. __( 'Creations are stored for a two years duration.', 'creator-five-for-woocommerce' ).'</p>';
		$table_name = $wpdb->prefix . 'c5woo_saved_creations';
		$sql = "SELECT product_id, project_id, creation_time FROM $table_name WHERE customer_id = $user;";
		$results = $wpdb->get_results($sql);
		echo '<table>';
		foreach ( $results as $result )  {
			$creator_five_product = new creator_five_product($result->product_id);
			$creator_five_product_id = $creator_five_product->product_id;
			$table_name = $wpdb->prefix . 'c5woo_saved_creations_versions';
			$version_sql = "SELECT variation_id, saved_key, saved_time, thumbnail_url FROM $table_name WHERE project_id = '$result->project_id' ORDER BY saved_time DESC LIMIT 0,1;";
			$versions = $wpdb->get_results($version_sql);
			foreach ( $versions as $version )  {
				echo '<tr>';
				echo '<td>'. $creator_five_product->product_name .'<br />'. __( 'Created:','creator-five-for-woocommerce' ).' '. $result->creation_time .'<br />'. __( 'Last saved:','creator-five-for-woocommerce' ).' '. $version->saved_time .'</td>';
				echo '<td><img src="'.$version->thumbnail_url.'"/></td>';
				echo '<td><form action="/personalize" method="post"><input type="hidden" name="C5WOO_application" value="creations" /><input type="hidden" name="product-id" value="' . $result->product_id . '" /><input type="hidden" name="variation-id" value="' . $version->variation_id . '" /><input type="hidden" name="saved_key" value="' . $version->saved_key . '" /><a class="before_add_to_cart_form secondary button alt creator_five_editor creator_five_editor_personalize_link"><button class="creator_five_editor_personalize_button" id="creator_five_personalize_product_ID_'.$creator_five_product_id.'">' . __('Open', 'creator-five-for-woocommerce') . '</button></a></form></td>';
				echo '<td><form action="/personalize?loadAsModel=1" method="post"><input type="hidden" name="C5WOO_application" value="creations" /><input type="hidden" name="product-id" value="' . $result->product_id . '" /><input type="hidden" name="saved_key" value="' . $version->saved_key . '" /><a class="before_add_to_cart_form secondary button alt creator_five_editor creator_five_editor_personalize_link"><button class="creator_five_editor_personalize_button" id="creator_five_personalize_product_ID_'.$creator_five_product_id.'">' . __('Open as model', 'creator-five-for-woocommerce') . '</button></a></form></td>';
				echo '<td><a href="#" class="before_add_to_cart_form secondary button alt creator_five_editor creator_five_editor_personalize_link" onclick="remove_creations_from_account(\''.$result->project_id.'\')"><button class="creator_five_editor_personalize_button" id="creator_five_personalize_product_ID_'.$creator_five_product_id.'">' . __('Delete', 'creator-five-for-woocommerce') . '</button></a></td>';
				echo '</tr>';
			}
		}
		echo '</table>';
?>
<script>
function remove_creations_from_account(creationid) {
	var ajaxurl = '<?php echo(admin_url( 'admin-ajax.php' )) ?>';
	
	var data = {
		action: 'remove_creations_from_account',
		creationid: creationid
	};
	
	jQuery.post(
		ajaxurl,
		data,
		function(response) {
			if(response != 0) {
				alert('<?php _e('An error occurred, got this from the server:', 'creator-five-for-woocommerce') ?> ' + response);
			} else {
				window.location.reload();
			}
		}
	);
	}
</script>
<?php
	}
}
