<?php
// woocommerce-customize-cart.php
// adds CSS to the cart page

if ( ! defined( 'ABSPATH' ) ) {
    exit;
}

add_action('wp_head', 'C5WOO_cart_hook_css');
function C5WOO_cart_hook_css() {
    if ( is_cart() or is_order_received_page() ) {
		if (get_option( 'wc_C5WOO_settings_display_debug_info_in_cart' ) == 'no') {
			$custom_css ='<style>';
			$custom_css .='.variation {display:none;}';
			$custom_css .='.wc-item-meta {display:none;}';
			$custom_css .='</style>';
			echo $custom_css;
		}
	}
}

add_filter( 'woocommerce_cart_item_name', 'C5WOO_cart_item_name', 10, 3 );
function C5WOO_cart_item_name( $product_name, $values, $cart_item_key ){
    if ( is_cart() ) {
		global $woocommerce, $wpdb;
		$cart_item = WC()->cart->cart_contents[ $cart_item_key ];
		$product_id = $cart_item['product_id'];
		$table_name = $wpdb->prefix . 'postmeta';
		$sql = "SELECT meta_value FROM $table_name WHERE post_id = $product_id AND meta_key = 'productGroup';";
		$results = $wpdb->get_results($sql);
		$productGroup = array("paper-prints","large-format-prints");
		if ( in_array($results[0]->meta_value, $productGroup) ){  
//			print_r($values);
			$product_name .= ' ('.$values[quantity].')';
		}
		return $product_name;
	}
}

add_filter( 'woocommerce_cart_item_quantity', 'C5WOO_cart_item_quantity', 10, 2 );
function C5WOO_cart_item_quantity( $product_quantity, $cart_item_key ){
    if ( is_cart() ) {
		global $woocommerce, $wpdb;
		$cart_item = WC()->cart->cart_contents[ $cart_item_key ];
		$product_id = $cart_item['product_id'];
		$table_name = $wpdb->prefix . 'postmeta';
		$sql = "SELECT meta_value FROM $table_name WHERE post_id = $product_id AND meta_key = 'productGroup';";
		$results = $wpdb->get_results($sql);
		$productGroup = array("paper-prints","large-format-prints");
		if ( in_array($results[0]->meta_value, $productGroup) ){  
			$product_quantity = '';
		}
		return $product_quantity;
	}
}

add_filter( 'woocommerce_cart_item_thumbnail', 'C5WOO_custom_new_product_image', 10, 3 );
function C5WOO_custom_new_product_image( $_product_img, $cart_item, $cart_item_key ) {
	if ($cart_item['variation']['thumbnail_url']) {
		$a = '<img src="https:'.$cart_item['variation']['thumbnail_url'].'" />';
	}
	else {
		$a = $_product_img;
	}
	return $a;
}

add_action('woocommerce_email_header', 'C5WOO_email_cart_hook_css');
function C5WOO_email_cart_hook_css() {
	if (get_option( 'wc_C5WOO_settings_display_debug_info_in_cart' ) == 'no') {
		$custom_css ='<style>';
		$custom_css .='.wc-item-meta {display:none;}';
		$custom_css .='</style>';
		echo $custom_css;
	}
}
