<?php

if ( ! defined( 'ABSPATH' ) ) {
    exit;
}

$product_id = sanitize_text_field($_POST['product-id']);

$creator_five_product = new creator_five_product($product_id);
$creator_five_editor = new creator_five_editor();

wp_enqueue_style('jquery-ui', plugins_url('/css/jquery-ui.css', __FILE__),'',C5WOO_VERSION);
wp_enqueue_style('font-awesome', plugins_url('/css/font-awesome.min.css', __FILE__),'',C5WOO_VERSION);
wp_enqueue_style('bootstrap', plugins_url('/css/bootstrap.min.css', __FILE__),'',C5WOO_VERSION);
wp_enqueue_style('diy-styles', plugins_url('/css/diy-styles.css', __FILE__),'',C5WOO_VERSION);
if (wp_is_mobile())
//	wp_enqueue_style('application', plugins_url('/css/creator-five-print.css', __FILE__),'',C5WOO_VERSION);
	wp_enqueue_style('application', plugins_url('/css/creator-five-print-mobile.css', __FILE__),'',C5WOO_VERSION);
else
	wp_enqueue_style('application', plugins_url('/css/creator-five-print.css', __FILE__),'',C5WOO_VERSION);

wp_dequeue_script('jquery');
wp_enqueue_script('jquery',plugins_url('/js/jquery.2.2.4.min.js', __FILE__),'',C5WOO_VERSION);
wp_enqueue_script('jquery-ui',plugins_url('/js/jquery-ui.1.12.1.min.js', __FILE__),array('jquery'),C5WOO_VERSION);
wp_enqueue_script('bootstrap',plugins_url('/js/bootstrap.3.3.7.min.js', __FILE__),array('jquery'),C5WOO_VERSION);
wp_enqueue_script('diy-application',C5WOO_REMOTE_PATH.'stable/js/diy-application.js',array('jquery'),C5WOO_VERSION);

wp_localize_script('script', 'ajaxurl', admin_url( 'admin-ajax.php' ) );

get_header('c5woo');
?>
<div id="koffeeprint" class="koffeeware-print"></div>
<script>
	KWP_CONF.client = '<?php echo $creator_five_editor->slug; ?>';
	KWP_CONF.version = 'stable';
	KWP_CONF.show_scissors = <?php echo $creator_five_editor->show_scissors; ?>;
	KWP_CONF.photoSize = '<?php echo $creator_five_editor->photo_container_width; ?>';

	var $ = jQuery;

	jQuery("#koffeeprint").koffeePrint({
		creator_five_id:<?php echo $creator_five_product->product_id; ?>,
		variation_id:<?php if(sanitize_text_field($_POST['variation-id']) == '') echo '0'; else echo sanitize_text_field($_POST['variation-id']); ?>,
		lock_product:true,
		contentStyle:{"padding-top":"84px"},

		onload: function() {
			KWP_utils.addLogo({
				url:'<?php echo $creator_five_editor->logo_url; ?>',
				href:'<?php echo $creator_five_editor->logo_link; ?>'
			});
			jQuery("#content .placeholder").fadeIn();
		},

		update: function(photo_id, photo) {
			jQuery("#upload_images").removeClass("disabled");
			var print_list = KWP_utils.getPrintList();
			if(print_list.length == 0) {
				jQuery("#upload_images").addClass("disabled");
			}
			var total_photos = 0;
			for(var x=0; x<print_list.length; x++) {
				total_photos += print_list[x].config.quantity;
			}
			jQuery("#total_qt").html(total_photos);
		},

		uploadComplete: function(descriptor_url, thumbnail_url, key) {
			var variation_id = 0;
			var total_photos = 0;
			var print_list = KWP_utils.getPrintList();
			for(var x=0; x<print_list.length; x++) {
				total_photos += print_list[x].config.quantity;
			}

			var ajaxurl = '<?php echo(admin_url( 'admin-ajax.php' )) ?>';

			var data = {
                action:'add_prints_to_cart',
				product_id:<?php echo $product_id; ?>,
				variation_id:variation_id,
				product_group:'<?php echo $creator_five_product->product_group ?>',				
				quantity:total_photos,
				printkey:key.toString(),
				thumbnailurl:thumbnail_url,
				descriptorurl:descriptor_url
            };
			
            jQuery.post(
				ajaxurl,
				data,
				function(response) {
					if(response != 0) {
						alert('<?php _e('An error occurred, got this from the server:', 'creator-five-for-woocommerce') ?> ' + response);
					} else {
						window.location.replace('<?php echo $creator_five_editor->complete_redirect; ?>');
					}
				}
            );
		}
	});
</script>
<?php

get_footer('c5woo');
exit;