<?php
// woocommerce-product-page.php
// adds a Personalize button on Creator Five products' page

if ( ! defined( 'ABSPATH' ) ) {
    exit;
}

add_action('wp_head', 'C5WOO_button_hook_css');
function C5WOO_button_hook_css() {
    if ( is_product() ) {
		global $product;
		$product = wc_get_product();

		if ( get_post_meta( $product->get_id(), 'productGroup', true ) != '' ) {
			$custom_css ='<style>';
			$custom_css .='.quantity{display:none;}';
			$custom_css .='.woocommerce-variation-add-to-cart{display:none;}';
//			$custom_css .='.variations{display:none;}';
			$custom_css .='.single_add_to_cart_button{display:none;}';
			$custom_css .='.creator_five_editor_personalize_link{'. get_option( 'wc_C5WOO_settings_css_creator_five_editor_personalize_link' ) .'}';
			$custom_css .='.creator_five_editor_personalize_button{'. get_option( 'wc_C5WOO_settings_css_creator_five_editor_personalize_button' ) .'}';
			$custom_css .='</style>';
			echo $custom_css;
		}
	}
}

// add_action('wp', 'C5WOO_custom_hide_buttons');
function C5WOO_custom_hide_buttons() {
	global $product;
	$product = wc_get_product();

	if ( ! $product == false ) {
		if ( $creator_five_product_id = get_post_meta( $product->get_id(), 'creator_five_product_id', true ) ) {
			$creator_five_product = explode(";", $creator_five_product_id);
			$creator_five_product_id = $creator_five_product[0];
			if ( $creator_five_product_id != '0' ) {
				remove_action('woocommerce_grouped_add_to_cart', 'woocommerce_grouped_add_to_cart', 30);
				remove_action('woocommerce_variable_add_to_cart', 'woocommerce_variable_add_to_cart', 30);
				remove_action('woocommerce_external_add_to_cart', 'woocommerce_external_add_to_cart', 30);
			}
		}
	}
}

add_action('woocommerce_before_add_to_cart_form', 'C5WOO_button_on_product_page', 30);
function C5WOO_button_on_product_page() {
	global $product;

	$product = wc_get_product();
	$product_id = $product->get_id();

	if ( $creator_five_product_id = get_post_meta( $product_id, 'creator_five_product_id', true ) ) {
		$creator_five_product = new creator_five_product($product_id);
		$creator_five_product_id = $creator_five_product->product_id;
		$creator_five_product_type = $creator_five_product->product_type;
		?>
	<script>
    jQuery(document).ready(function(jQuery) {
/*
		if( '' != jQuery('input.variation_id').val() )
			jQuery('#variation-id').val(jQuery('input.variation_id').val());

        jQuery('select').blur( function(){
            if( '' != jQuery('input.variation_id').val() )
                jQuery('#variation-id').val(jQuery('input.variation_id').val());
        });

*/
        jQuery('.creator_five_editor_personalize_button').click( function(){
            if( '' != jQuery('input.variation_id').val() )
				jQuery('#variation-id').val(jQuery('input.variation_id').val());
        });
	});
    </script>
		<?php

		if (c5woo_wp_is_mobile()) {
			wc_enqueue_js( "jQuery('button.single_add_to_cart_button').hide();" );
			echo '<p>' . __('Sorry, this product can not be ordered on mobile phones.', 'creator-five-for-woocommerce') . '</p>';
		}
		else {
			if ( $creator_five_product_id != '0' ) {
				wc_enqueue_js( "$('button.single_add_to_cart_button').hide();" );
				if ($creator_five_product_type == 'prints' OR $creator_five_product_type == 'large_prints') {
					if (get_option( 'wc_C5WOO_settings_prints_ordering_button_text' ) == '')
						$button = __('Order', 'creator-five-for-woocommerce');
					else
						$button = get_option( 'wc_C5WOO_settings_prints_ordering_button_text' );
					echo '<form action="/personalize" method="post"><input type="hidden" name="C5WOO_application" value="prints" /><input type="hidden" name="product-id" value="' . $product_id . '" /><input type="hidden" id="variation-id" name="variation-id" value="0" /><a class="before_add_to_cart_form secondary button alt creator_five_editor creator_five_editor_personalize_link"><button class="creator_five_editor_personalize_button" id="creator_five_personalize_product_ID_'.$creator_five_product_id.'">' . $button . '</button></a></form>';
				}
				else {
					if (get_option( 'wc_C5WOO_settings_creations_editor_button_text' ) == '')
						$button = __('Create', 'creator-five-for-woocommerce');
					else
						$button = get_option( 'wc_C5WOO_settings_creations_editor_button_text' );
					if (get_option( 'wc_C5WOO_settings_customer_login' ) == 'yes') {
						if(is_user_logged_in()) {
							echo '<form action="/personalize" method="post"><input type="hidden" name="C5WOO_application" value="creations" /><input type="hidden" name="product-id" value="' . $product_id . '" /><input type="hidden" id="variation-id" name="variation-id" value="0" /><input type="hidden" name="saved_key" value="" /><a class="before_add_to_cart_form secondary button alt creator_five_editor creator_five_editor_personalize_link"><button class="creator_five_editor_personalize_button" id="creator_five_personalize_product_ID_'.$creator_five_product_id.'">' . $button . '</button></a></form>';						}
						else {
							$siteurl = site_url();
							$url = urlencode(get_permalink());
							echo '<form action="'. $siteurl .'/wp-login.php?redirect_to=' . $url .'&reauth=1" method="post"><a class="before_add_to_cart_form secondary button alt creator_five_editor creator_five_editor_personalize_link"><button class="creator_five_editor_personalize_button" id="creator_five_personalize_product_ID_'.$creator_five_product_id.'">' . __('Log in to create', 'creator-five-for-woocommerce') . '</button></a></form>';
						}
					}
					else {
						echo '<form action="/personalize" method="post"><input type="hidden" name="C5WOO_application" value="creations" /><input type="hidden" name="product-id" value="' . $product_id . '" /><input type="hidden" id="variation-id" name="variation-id" value="0" /><input type="hidden" name="saved_key" value="" /><a class="before_add_to_cart_form secondary button alt creator_five_editor creator_five_editor_personalize_link"><button class="creator_five_editor_personalize_button" id="creator_five_personalize_product_ID_'.$creator_five_product_id.'">' . $button . '</button></a></form>';
					}
				}
			}
		}
	}
}

add_filter( 'woocommerce_loop_add_to_cart_link', 'C5WOO_change_add_to_cart_link', 10, 2 );
function C5WOO_change_add_to_cart_link($link, $product) {
    $enable_creator_five = get_post_meta( get_the_ID(), 'creator_five_product_id', true );
	
	if( $enable_creator_five && $enable_creator_five != 0 ) {
		$product_id = get_the_ID();
		$buttons = sprintf( '<a href="%s" class="%s">%s</a>',
			esc_url( $product->get_permalink() ),
			esc_attr( isset( $class ) ? $class : 'button' ),
			esc_html( __( 'Read more', C5WOO_DOMAIN ) )
		);
		return $buttons;

	}
	return $link;
}
